
/* teensy speed test for d/a, with 50 samples per sine cycle
 * appears to run 5.319+ khz with no wait, ~ 3.5 us/sample.
 * With 4 us wait, about 4.35 khz
 */

#include <TimerOne.h>
#define led 13
int ledState = LOW;

byte i;
int value[50];

float phase = 0.0;
float twopi = 3.14159 * 2;
elapsedMicros usec = 0;

void setup() {
  analogWriteResolution(12);
  for (i=0;i<50;i++) // make a table so we're not measuring speed of sin function
  {
   value[i] = int (sin(phase) * 2000 + 2050.0);
   phase = phase + .1256636;//0.0628318; // 2 pi / 100
  }
  i=0;
  pinMode(led, OUTPUT);
  Timer1.initialize(100000);
  Timer1.attachInterrupt(blinkLED); // blinkLED to run every 0.15 seconds

} // end setup

void blinkLED(void) // timer 1 ISR
{
  if (ledState == LOW) {
    ledState = HIGH;
//    blinkCount = blinkCount + 1;  // increase when LED turns on
  } else {
    ledState = LOW;
  }
  digitalWrite(led, ledState);
}

void loop() {
  analogWrite(A14, value[i++]);
  if (i > 49) i=0;
  while (usec < 5) ; // wait
  usec = usec - 5;
}
